/*
Nome Modulo:		eeprom_internal.c

Descrizione:
Funzioni per scrivere valori ad 8, 16 e 32 bit nell'eeprom
interna del PICMicro

Linguaggio:			HITEC-C (ansi C)
Versione:			1.0
Data Emissione:		08/01/2010
Autore:			Bernardo Giovanni
Sito web:			http://www.settorezero.com
*/

// legge un BYTE (8bit)  dall'indirizzo specificato in "address"
unsigned char eei_read_byte(unsigned char EEaddress)
	{
	EEADR=EEaddress; // indirizzo da cui leggere
	EEPGD=0; // accesso alla memoria eeprom
	RD=1; // avvio la lettura
	// il valore contenuto in EEDATA  disponibile dal prossimo ciclo
	// se effettuo un return EEDATA, non ottengo nulla
	char EEVALUE;
	EEvalue=EEDATA;
	return EEvalue;
	}

// scrive un BYTE (8 bit) (valore "EEdata") nell'indirizzo specificato in "EEaddress"
void eei_write_byte(unsigned char EEdata, unsigned char EEaddress)
	{
	EEADR=EEaddress; // indirizzo in cui scrivere
	EEDATA=EEdata; // dati da scrivere
	EEPGD=0; // accesso alla memoria eeprom
	WREN=1; // abilito la scrittura                            
	// Controllo se sono attivi gli interrupt e mi memorizzo la condizione
	static bit PREGIE=0;	
	if (GIE) 
		{
		PREGIE=1;	
		GIE=0; // disabilito gli interrupt
		}
	// Queste due istruzioni che seguono sono richieste (vedi datasheet) per avviare la scrittura
	EECON2=0x55;
	EECON2=0xAA;
	WR=1; // avvio un ciclo di scrittura
	while(!EEIF); // attendo che la scrittura sia completa
	WREN=0; // disabilito la scrittura sull'eeprom
	EEIF=0; // resetto il flag di scrittura completa
	 // reimposto gli interrupt allo stato in cui si trovavano
	if (PREGIE)
		{
		GIE=1;
		}
	}
	
