//*************************************************
// CENTRALINA PER AUTOMATIZZARE LE PERSIANE
//
// modulo: main.c
// autore: Longhi Ferdinando
// data: 28/08/2012
// descrizione: centralina per persiane a 2 ante
// picmicro: PIC16F88
// clock: 8MHz interno
// NOTE:gestione della velocit con PWM + controllo remoto da bus rs485
//
// http://www.settorezero.com
//  severamente vietata la ridistribuzione del 
// codice o di parti di esso senza esplicita
// autorizzazione
//*************************************************

#define  XTAL_FREQ 8MHZ // questo  utilizzato dalle routine di ritardo contenute in Delay.C
#include <htc.h>
#include "settings.h"//qui trovo i settaggio generali
#include "delay.c" // routine per ritardi
#include "pwm.c"// rourine PWM
#include "usart.c"//routine per gestione della seriale
#include "send.c"
#include "eeprom_internal.c" //routine per eeprom

__CONFIG (FOSC_INTOSCIO & WDTE_OFF & PWRTE_OFF & BOREN_OFF & LVP_OFF & CPD_OFF & WRT_OFF & DEBUG_OFF & CP_OFF & CCPMX_RB3);
void main(void)
{
settings();
init_comms();	// settaggi per la  USART
PWMSetup();		// settaggi per la  PWM
//*************************************************
// inizializzo alcune uscite
//*************************************************
EN=0;//disabilito la trasmissione RS485
LedPrg=0;//spengo il LED di programmazione
Out1=0;//tutti..
Out2=0;//...i motori...
Out3=0;//...sono a ...
Out4=0;//...riposo
duty=255;//equivale a mettere a 1 il pin enable del L293D;era256
PWMDuty(duty);// PWM al 100%
//*************************************************
// leggo o scrivo sulle EEprom
//*************************************************
if (eei_read_byte(0)==10)//verifico se il modulo e' gia' stato programmato
		{
Address=eei_read_byte(1); // leggo il valore Address nella locazione di memoria 1:il modulo e' alla prima accensione
Group=eei_read_byte(2); // leggo il valore Group nella locazione di memoria 2
Time1=eei_read_byte(3); // leggo il valore Time1 nella locazione di memoria 3
Time2=eei_read_byte(4); // leggo il valore Time2 nella locazione di memoria 4
Time3=eei_read_byte(5); // leggo il valore Time3 nella locazione di memoria 5
Time4=eei_read_byte(6); // leggo il valore Tima4 nella locazione di memoria 6
TRal=eei_read_byte(7); // leggo il valore TRal nella locazione di memoria 7
Arb=eei_read_byte(8); // leggo il valore Arb nella locazione di memoria 8
duty=eei_read_byte(9); // leggo il valore duty nella locazione di memoria 9
		}
else
		{
eei_write_byte(10,0); // cambio il valore per segnalare che ho gia' il modulo non e' alla prima accensione
eei_write_byte(Address,1); // scrivo il valore Address nella locazione di memoria 1
eei_write_byte(Group,2); // scrivo il valore Group nella locazione di memoria 2
eei_write_byte(Time1,3); // scrivo il valore Time1 nella locazione di memoria 3
eei_write_byte(Time2,4); // scrivo il valore Time2 nella locazione di memoria 4
eei_write_byte(Time3,5); // scrivo il valore Time3 nella locazione di memoria 5
eei_write_byte(Time4,6); // scrivo il valore Time4 nella locazione di memoria 6
eei_write_byte(TRal,7); // scrivo il valore TRal nella locazione di memoria 7
eei_write_byte(Arb,8); // scrivo il valore Arb nella locazione di memoria 8
eei_write_byte(duty,9); // scrivo il valore duty nella locazione di memoria 9
		}

//*************************************************
// avviso il master che sono vivo
//*************************************************
Send(Dest,Address,Group,0,0,0);//invio il telegramma

	while(1) // eseguo un ciclo finito
	{

//*************************************************
// inizio controllo pulsante apre/stop/chiude
//*************************************************
		while (1)
		{
//*************************************************
// controllo pulsante prg
//*************************************************
if (InPrg==1)//verifico se e' premuto tasto programmazione
		{

			while (InPrg)//aspetto che rilascio il pulsante
				{
				DelayMs(Arb);
				}
				Send(Dest,Address,Group,0,0,0);//invio il telegramma
				LedPrg=1;
				while(LedPrg)
				{
					if (InPrg==1)//verifico se e' premuto
					{
					while (InPrg)//aspetto che rilascio il pulsante
					{
					DelayMs(Arb);
					}
						LedPrg=0;
						InPrg=0;
					}
				}
		}

		if (Pul==0||Apro==1||ApCh==1)//verifico se e' premuto il pulsante o ricevo dati 
			{
			while (!Pul)//aspetto che rilascio il pulsante
					{
					DelayMs(Arb);
					}

//*************************************************
// Apro la prima anta
//*************************************************
					Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
					Out1=1;//Apro la prima anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per uscire dal while
					while (Brk)
					{
						if (Sec >=Time1)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dal while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=ValDuty;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							Out1=0;
							duty=255;//duty cycle 100%
							PWMDuty(duty);
						Data1=Data1&0b00111000;//azzero i vecchi flag 1 anta in memoria
						Data1=Data1|0b00000001;//alzo il flag anta 1 aperta	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out1=0;//fermo la prima anta
								Brk=0;//esco dal while
						Data1=Data1&0b00111000;//azzero i vecchi flag 1 anta in memoria
						Data1=Data1|0b00000100;//alzo il flag anta 1 bloccata	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
								}
						}
						else if (Pul==0||Apro==1||ApCh==1)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								DelayMs(Arb);
								}
							Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
							Out1=0;//fermo la prima anta
							Brk=0;//esco dal while
						Data1=Data1&0b00111000;//azzero i vecchi flag 1 anta in memoria
						Data1=Data1|0b00000010;//alzo il flag anta 1 fermata	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
								}//fine if
					}//fine while
//*************************************************
// Apro la seconda anta
//*************************************************
					DelayMs(250);//attendo per evitare false letture di amperostop
					Out2=1;//Apro la seconda anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time2)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dall while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=ValDuty;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}//fine while
							Out2=0;
							duty=255;//duty cycle di circa 100%
							PWMDuty(duty);
						Data1=Data1&0b00000111;//azzero i vecchi flag 2 anta in memoria
						Data1=Data1|0b00001000;//alzo il flag anta 2 aperta	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
						}//fine if
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
							{
								Out2=0;//fermo la seconda anta
								Brk=0;//esco dall while
						Data1=Data1&0b00000111;//azzero i vecchi flag 2 anta in memoria
						Data1=Data1|0b00100000;//alzo il flag anta 2 in aperostop	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
							}//fine if
						}//fine if
						else if (Pul==0||Apro==1||ApCh==1)//verifico se e' premuto il pulsante
						{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								DelayMs(Arb);
								}
							Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
							Out2=0;//fermo la seconda anta
							Brk=0;//esco dall while
						Data1=Data1&0b00000111;//azzero i vecchi flag 2 anta in memoria
						Data1=Data1|0b00010000;//alzo il flag anta 2 fermata	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
						}
						//}//fine if
					}//fine while
					break;
			}//fine if
		}//fine while
//*************************************************
// inizio controllo pulsante apre/stop/chiude
//*************************************************
		while (1)
		{
		
			if (Pul==0||Chiudo==1||ApCh==1)//verifico se e' premuto il pulsante o ricevo dati 
			{
				while (!Pul)//aspetto che rilascio il pulsante
					{
					DelayMs(Arb);
					}
//*************************************************
// Chiudo la seconda anta
//*************************************************
					Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
					Out3=1;//Chiudo la seconda anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time3)//verifico se e' scaduto il tempo
						{
							Brk=0;//esco dall while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=ValDuty;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							duty=255;//duty cycle di circa 100%
							PWMDuty(duty);
							DelayMs(250);//...per mezzo secondo...
							Out3=0;//...per accostarla bene
						Data1=Data1&0b00000111;//abbasso il flag anta 2 chiusa	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;//punto di partenza per in tempo del amperostop
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out3=0;//fermo la prima anta
								Brk=0;//esco dall while
						Data1=Data1&0b00000111;//azzero i vecchi flag 2 anta in memoria
						Data1=Data1|0b00100000;//alzo il flag anta 2 in amperostop	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,6,State,0);//invio il telegramma
								}
						}
						else if (Pul==0||Chiudo==1||ApCh==1)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								DelayMs(Arb);
								}
								Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
								Out3=0;//fermo la prima anta
								Brk=0;//esco dall while
						Data1=Data1&0b00000111;//azzero i vecchi flag 2 anta in memoria
						Data1=Data1|0b00010000;//alzo il flag anta 2 fermata	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
								}//fine if
						}//fine while
					//}
					//}
//*************************************************
// Chiudo la prima anta
//*************************************************
					DelayMs(250);//attendo per evitare false letture di amperostop
					Out4=1;//Apro la prima anta
					Sec=0;//azzero il conteggio dei secondi
					Brk=1;//flag per restare nel while
					while (Brk)
					{
						if (Sec >=Time4)//verifico se e' scaduto il tempo
						{
							//Out4=0;//Fermo la prima anta
							Brk=0;//esco dal while
							TimeRal=Sec;//punto di partenza per in tempo del rallentamento
							duty=ValDuty;//duty cycle di circa 50%
							PWMDuty(duty);
							while(!((Sec-TimeRal)>=TRal))//inizio la fase di rallentamento
							{
							}
							duty=255;//duty cycle di circa 100%
							PWMDuty(duty);
							DelayMs(250);//per mezzo secondo...
							Out4=0;//...per accostarla bene
						Data1=Data1&0b11111000;//abbasso il flag anta 1 chiusa	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
						}
						else if (Amp==1)//verifico se e' in amperostop
						{
							TimeAmp=Sec;//punto di partenza per in tempo del amperostop
							while(!((Sec-TimeAmp)>=2))//aspetto 2 secondi
							{
							}
							if (Amp==1)//e' ancora in amperostop?
								{
								Out4=0;//fermo la prima anta
								Brk=0;//Fermo la prima anta
						Data1=Data1&0b00111000;//azzero i vecchi flag 1 anta in memoria
						Data1=Data1|0b00000100;//alzo il flag anta 1 in amperostop	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
								}
						}
						else if (Pul==0||Chiudo==1||ApCh==1)//verifico se e' premuto il pulsante
								{
								while (!Pul)//aspetto che rilascio il pulsante
								{
								DelayMs(Arb);
								}
								Apro=Chiudo=ApCh=0;//cancello il byte ricevuto in rs485	
								Out4=0;//fermo la prima anta
								Brk=0;//Fermo la prima anta
						Data1=Data1&0b00111000;//azzero i vecchi flag 1 anta in memoria
						Data1=Data1|0b00000010;//alzo il flag anta 1 fermata	
						State=Data1;//menorizzo lo stato nella sua variabile
						Send(Dest,Address,Group,1,State,0);//invio il telegramma
								}//fine if
						//}//fine if
					}//fine while
					break;
				}//fine if
		}//fine while
	}// Fine ciclo continuo
}// Fine main
//*************************************************
// interrupt del TMR0
//*************************************************
void interrupt ISR (void)
 {
    if (TMR0IF) // L'interrupt  stato causato da un overflow del timer0 ?
       {
       TMR0 = 194; // Reimposto Timer0
       Time++; // Incremento il Time
       if (Time >= 1000) // Se   passato un secondo...
          {
          Sec++; // ...incremento la variabile
          Time=0; // azzero il time per un nuovo conteggio del tempo
          }
       TMR0IF=0; // Resetto il flag interrupt su timer 0,
       } // fine che interrupt verificatosi su timer0
//*************************************************
// interrupt della porta seriale
//*************************************************	   
	if (RCIF == 1 )			// Controllo che l'interrupt sia stato generato dall'USART
	{
	Input[1] = getch(); 	// leggo il dato dal buffer di ricezione: indirizzo di un modulo
	Input[0] = getch(); 	// leggo il dato dal buffer di ricezione: indirizzo di chi invia
	Input[2] = getch();		// leggo il dato dal buffer di ricezione: gruppo
	Input[3] = getch(); 	// leggo il dato dal buffer di ricezione: comando
	Input[4] = getch(); 	// leggo il dato dal buffer di ricezione: dato 1
	Input[5] = getch(); 	// leggo il dato dal buffer di ricezione: dato 2
//	Send(Input[1],Input[0],Input[2],Input[3],Input[4],Input[5]);//cosa ho ricevuto
	
	if (Input[1]==Address && Input[3]==1) goto ReadStatus;//Leggo lo stato del modulo 
	else if (Input[1]==Address && Input[3]==2) goto Write;//scrivo il valori come da tabella 
	else if ((Input[1]==Address || Input[2]==Group) && Input[3]==3) goto comando;//eseguo una delle seguenti azioni
	else if (LedPrg==1 && Input[3] ==4) goto newaddress;//acquisisco indirizzo da remoto se sono in modalita' prog.
	else if (Input[1]==Address && Input[3]==5) goto ReadValue;//legge i valori come da tabella
	
	}//fine interrupt dati USART
	return;
//*************************************************
// leggi stato modulo: come sono messe le ante?
//*************************************************
ReadStatus:
//lo stato dell'anta 1 la si ricava dal bit0, bit1 e bit2 della variabile state 
//lo stato dell'anta 2 la si ricava dal bit3, bit4 e bit5 della variabile state
//	bit3	bit 1	bit0
//	0		0		0	anta 1 chiusa completamente
//	0		0		1	anta 1 aperta completamente
//	0		1		0	anta 1 fermata con pulsante o comando remoto (parzialmente aperta)
//	1		0		0	anta bloccata da un ostacolo (parzialmente aperta)
//	bit5	bit 4	bit3
//	0		0		0	anta 2 chiusa completamente
//	0		0		1	anta 2 aperta completamente
//	0		1		0	anta 2 fermata con pulsante o comando remoto (parzialmente aperta)
//	1		0		0	anta bloccata da un ostacolo (parzialmente aperta)
// interpretando il valore binario della variabile state determino la posizione delle due ante
			
				Send(Dest,Address,Group,6,State,0);//invio il telegramma
				return;
//*************************************************
// scrivi i nuovi valori inviati da remoto
//*************************************************
Write:
//		Data1	=	2	Group=Dato2 	gruppo modulo
//		Data1	=	3	Time1=Dato2 	tempo apertura anta 1
//		Data1	=	4	Time2=Dato2 	tempo apertura anta 2
//		Data1	=	5	Time3=Dato2 	tempo chiusura anta 2
//		Data1	=	6	Time4=Dato2 	tempo chiusura anta 1
//		Data1	=	7	TRal=Dato2 		tempo di rallentamento	
//		Data1	=	8	Arb=Dato2 		valore dell'antirimbalzo 
//		Data1	=	9	ValDuty=Dato2 	valore di duty cycle (0-255  =  0-100%)	

				if (Input[4] ==2)// voglio scrivere il valore di Group 	gruppo del modulo
				{
				Group=Input[5];//memorizzo il valore
				eei_write_byte(Group,2); // scrivo il valore duty nella locazione di memoria 2
				}
				else if (Input[4] ==3)// voglio scrivere il valore di Time1 	tempo apertura anta 1
				{
				Time1=Input[5];//memorizzo il valore
				eei_write_byte(Time1,3); // scrivo il valore duty nella locazione di memoria 3
				}
				else if (Input[4] ==4)// voglio scrivere il valore di Time2 	tempo apertura anta 2
				{
				Time2=Input[5];//memorizzo il valore
				eei_write_byte(Time2,4); // scrivo il valore duty nella locazione di memoria 4
				}
				else if (Input[4] ==5)// voglio scrivere il valore di Time3 	tempo chiusura anta 2
				{
				Time3=Input[5];//memorizzo il valore
				eei_write_byte(Time3,5); // scrivo il valore duty nella locazione di memoria 5
				}
				else if (Input[4] ==6)// voglio scrivere il valore di Time4 	tempo chiusura anta 1
				{
				Time4=Input[5];//memorizzo il valore
				eei_write_byte(Time4,6); // scrivo il valore duty nella locazione di memoria 6
				}
				else if (Input[4] ==7)// voglio scrivere il valore di TRal 	tempo di rallentamento
				{
				TRal=Input[5];//memorizzo il valore
				eei_write_byte(TRal,7); // scrivo il valore duty nella locazione di memoria 7
				}
				else if (Input[4] ==8)// voglio scrivere il valore di Arb tempo dell'antirimbalzo
				{
				Arb=Input[5];//memorizzo il valore
				eei_write_byte(Arb,8); // scrivo il valore duty nella locazione di memoria 8
				}
				else if (Input[4] ==9)// voglio scrivere il valore di Duty 	tempo di rallentamento
				{
				ValDuty=Input[5];//memorizzo il valore
				eei_write_byte(ValDuty,9); // scrivo il valore duty nella locazione di memoria 9
				}
				return;
//*************************************************
// invia comando
//*************************************************
comando:
//		Data1	=	1	allora apro le persiane
//		Data1	=	2	allora chiudo le persiane
//		Data1	=	3	allora inverto lo stato delle persiane (se aperte le chiudo e vicev.)
				if (Input[4] ==1)// corrisponde al comando apre
				{
					Apro=1;//flag per aprire da remoto
				}
				else if (Input[4] ==2)// corrisponde al comando chiude
				{
					Chiudo=1;//flag per aprire da remoto
				}
				else if (Input[4] ==3)// corrisponde al comando inverti stato
				{
					ApCh=1;//flag per aprire da remoto
				}
				return;
//*************************************************
// scrivi nuovo indirizzo modulo
//*************************************************

newaddress:
//		sintassi di chi manda (solo da indirizzo 0):
//		Data1	=	4	Address=Dato2 	indirizzo modulo
//		Address,0,x,4,Newaddress,x		x=non rilevante
				AddressOld = Address;
				Address = Input[4];
				Send(Dest,Address,Group,0,0,0);//invio il telegramma
				eei_write_byte(Address,1); // scrivo indirizzo nuovo nella cella 1
				LedPrg=0;
				return;

//*************************************************
// legge i valori di alcuni parametri della centralina
//*************************************************
ReadValue:
//		Data1	=	2	Dato2=Group 	gruppo modulo
//		Data1	=	3	Dato2=Time1 	tempo apertura anta 1
//		Data1	=	4	Dato2=Time2 	tempo apertura anta 2
//		Data1	=	5	Dato2=Time3 	tempo chiusura anta 2
//		Data1	=	6	Dato2=Time4 	tempo chiusura anta 1
//		Data1	=	7	Dato2=TRal 		tempo di rallentamento	
//		Data1	=	8	Dato2=Arb 		valore dell'antirimbalzo 
//		Data1	=	9	Dato2=duty 		valore di duty cycle (0-255  =  0-100%)

					if (Input[4] ==2)// voglio sapere il valore di Group del modulo
					{
					Send(Dest,Address,Group,Input[3],Input[4],Group);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==3)// voglio sapere il valore di Time1 	tempo apertura anta 1
					{
					Send(Dest,Address,Group,Input[3],Input[4],Time1);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==4)// voglio sapere il valore di Time2 	tempo apertura anta 2
					{
					Send(Dest,Address,Group,Input[3],Input[4],Time2);//invio il telegramma di risposta su Data2
					}	
					else if (Input[4] ==5)// voglio sapere il valore di Time3 	tempo chiusura anta 2
					{
					Send(Dest,Address,Group,Input[3],Input[4],Time3);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==6)// voglio sapere il valore di Time4 	tempo chiusura anta 1
					{
					Send(Dest,Address,Group,Input[3],Input[4],Time4);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==7)// voglio sapere il valore di Tral tempo di rallentamento
					{
					Send(Dest,Address,Group,Input[3],Input[4],TRal);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==8)// voglio sapere il di valore di Arb antirimbalzo
					{
					Send(Dest,Address,Group,Input[3],Input[4],Arb);//invio il telegramma di risposta su Data2
					}
					else if (Input[4] ==9)// voglio sapere il di valore di duty cycle
					{
					Send(Dest,Address,Group,Input[3],Input[4],ValDuty);//invio il telegramma di risposta su Data2
					}
					return;

 } // fine interrupt